#!/bin/sh

if [ ! "`pwd`" = "/" ]; then ##Woof build
	echo "Installing PupMenu"

else ##Conventional PET install
	[ -f /usr/share/applications/video-info-glx.desktop ] && sed -i 's%Graphics/CPU%Graphics|CPU%' /usr/share/applications/video-info-glx.desktop
	[ -f /usr/local/PupMenu/bookmarks ] && grep -v '#' /usr/local/PupMenu/bookmarks >> $HOME/.pbookmarks/bookmarks && rm -f  /usr/local/PupMenu/bookmarks

	# Add perl Escape.pm for pRecent-files
	if [ -d /usr/lib/perl5 ]; then # old quirky (32/64 bit), racy, wary and old slacko
	 cp -rf /tmp/perl/URI /usr/lib/perl5/5.*.* 2>/dev/null
	 cp -f /tmp/perl/Escape.pm /usr/lib/perl5/5.*.* 2>/dev/null
	fi
	if [ -d /usr/lib/perl ]; then # debian/ubuntu pups including precise, raring, tahrpup/tahrpup64, unicorn, wheezy, xenialpup/xenialpup64
	 cp -rf /tmp/perl/URI /usr/lib/perl/5.*.* 2>/dev/null
	 cp -f /tmp/perl/Escape.pm /usr/lib/perl/5.*.* 2>/dev/null
	fi
	if [ -d /usr/share/perl5 ]; then # recent quirky/easy and recent slacko/slacko64
	 cp -rf /tmp/perl/URI /usr/share/perl5 2>/dev/null
	 cp -f /tmp/perl/Escape.pm /usr/share/perl5 2>/dev/null
	fi
	if [ -d /usr/share/perl ]; then # alternate @INC
	 cp -rf /tmp/perl/URI /usr/share/perl/5.*.* 2>/dev/null
	 cp -f /tmp/perl/Escape.pm /usr/share/perl/5.*.* 2>/dev/null
	fi

	# Fix icon-paths in recent Pups
	if [ "`grep Slacko /etc/DISTRO_SPECS 2>/dev/null`" ]; then # Slacko
	 if [ -d /usr/share/pixmaps/puppy ]; then
	  sed -i 's/^.*Icon=.*$/Icon=\/usr\/share\/pixmaps\/puppy\/firewall.svg/' /usr/share/applications/firewallstate.desktop
	  sed -i 's/^.*Icon=.*$/Icon=\/usr\/share\/pixmaps\/puppy\/menu.svg/' /usr/share/applications/menumanager.desktop
	  sed -i 's/^.*Icon=.*$/Icon=\/usr\/share\/pixmaps\/puppy\/startup_app.svg/' /usr/share/applications/startupcontrol.desktop
	 fi
	fi
	if [ "`grep Wheezy /etc/DISTRO_SPECS 2>/dev/null`" ]; then # Wheezy
	 if [ -d /usr/share/pixmaps/puppy ]; then
	  sed -i 's/^.*Icon=.*$/Icon=\/usr\/share\/pixmaps\/puppy\/startup.svg/' /usr/share/applications/BootManager-configure-bootup.desktop 2>/dev/null
	  sed -i 's/^.*Icon=.*$/Icon=\/usr\/share\/pixmaps\/puppy\/font.svg/' /usr/share/applications/FontManager.desktop 2>/dev/null
	  sed -i 's/^.*Icon=.*$/Icon=\/usr\/share\/pixmaps\/puppy\/network.svg/' /usr/share/applications/ipinfo-network-information.desktop 2>/dev/null
	  sed -i 's/^.*Icon=.*$/Icon=squashfs-image.png/' /usr/share/applications/sfsconvert.desktop 2>/dev/null
	 fi
	fi
	if [ "`grep Raring /etc/DISTRO_SPECS 2>/dev/null`" ]; then # Raring
	  sed -i 's/^.*Icon=.*$/Icon=squashfs-image.png/' /usr/share/applications/sfsconvert.desktop 2>/dev/null
	fi

	# BK's Quirky/Easy requirements (note: also requires perl Escape.pm for the pRecent-files module of PupMenu, see above)
	. /etc/DISTRO_SPECS
	if [[ $(echo $DISTRO_NAME | grep -iE 'quirky|easy') ]]; then
	  sed -i 's/^.*Icon=.*$/Icon=\/usr\/share\/mmarchitect\/icons\/mmarchitect_48.png/' /usr/share/applications/mmarchitect.desktop
	  sed -i 's/^.*Icon=.*$/Icon=\/usr\/share\/mmarchitect\/icons\/mmarchitect_48.png/' /usr/share/applications/mmarchitect-help.desktop
	  if [[ $(echo $DISTRO_NAME | grep -i 'quirky' | grep '64') ]] || [[ $(echo $DISTRO_NAME | grep -i 'easy') ]]; then # Quirky64 or Easy Linux (presumably 64-bit only)
	    if [ -f /lib/x86_64-linux-gnu/libpng12.so.0 ]; then
	      ln -sf /lib/x86_64-linux-gnu/libpng12.so.0 /lib/x86_64-linux-gnu/libpng14.so.14
	    elif [ -f /usr/lib64/libpng12.so.0 ]; then
	      ln -sf /usr/lib64/libpng12.so.0 /usr/lib64/libpng14.so.14
	    elif [ -f /usr/lib64/libpng12.so.0.44.0 ]; then
	      ln -sf /usr/lib64/libpng12.so.0.44.0 /usr/lib64/libpng14.so.14
	    fi
	    ln -sf /usr/local/lib/X11/pixmaps/folder24.png /usr/local/lib/X11/pixmaps/folders24.png
	  else # Quirky32 symlinks for Recent-Files module of PupMenu
	    ln -snf /usr/share/perl/5.*/warnings /usr/share/perl5
	    ln -sf /usr/share/perl/5.*/Carp.pm /usr/share/perl5
	    ln -sf /usr/share/perl/5.*/Exporter.pm /usr/share/perl5
	    ln -sf /usr/share/perl/5.*/strict.pm /usr/share/perl5
	    ln -sf /usr/share/perl/5.*/vars.pm /usr/share/perl5
	    ln -sf /usr/share/perl/5.*/warnings.pm /usr/share/perl5
	  fi
	fi

	# Check default apps for categories and icons
	[ -f /usr/share/applications/defaultaudioplayer.desktop ] && [ ! "`grep '^Categories' /usr/share/applications/defaultaudioplayer.desktop`" ] && echo "Categories=Audio" >> /usr/share/applications/defaultaudioplayer.desktop
	[ -f /usr/share/applications/defaultbrowser.desktop ] && [ ! "`grep '^Categories' /usr/share/applications/defaultbrowser.desktop`" ] && echo "Categories=X-Internet-browser" >> /usr/share/applications/defaultbrowser.desktop
	[ -f /usr/share/applications/defaultchmviewer.desktop ] && [ ! "`grep '^Categories' /usr/share/applications/defaultchmviewer.desktop`" ] && echo "Categories=X-Document-viewer" >> /usr/share/applications/defaultchmviewer.desktop
	[ -f /usr/share/applications/defaultimageviewer.desktop ] && [ ! "`grep '^Categories' /usr/share/applications/defaultimageviewer.desktop`" ] && echo "Categories=Presentation" >> /usr/share/applications/defaultimageviewer.desktop
	[ -f /usr/share/applications/defaultmediaplayer.desktop ] && [ ! "`grep '^Categories' /usr/share/applications/defaultmediaplayer.desktop`" ] && echo "Categories=AudioVideo" >> /usr/share/applications/defaultmediaplayer.desktop
	[ -f /usr/share/applications/defaultpdfviewer.desktop ] && [ ! "`grep '^Categories' /usr/share/applications/defaultpdfviewer.desktop`" ] && echo "Categories=X-Document-viewer" >> /usr/share/applications/defaultpdfviewer.desktop
	[ -f /usr/share/applications/defaultspreadsheet.desktop ] && [ ! "`grep '^Categories' /usr/share/applications/defaultspreadsheet.desktop`" ] && echo "Categories=X-Business-spreadsheet" >> /usr/share/applications/defaultspreadsheet.desktop
	[ -f /usr/share/applications/defaulttexteditor.desktop ] && [ ! "`grep '^Categories' /usr/share/applications/defaulttexteditor.desktop`" ] && echo "Categories=TextEditor" >> /usr/share/applications/defaulttexteditor.desktop
	[ -f /usr/share/applications/defaultwordprocessor.desktop ] && [ ! "`grep '^Categories' /usr/share/applications/defaultwordprocessor.desktop`" ] && echo "Categories=WordProcessor" >> /usr/share/applications/defaultwordprocessor.desktop

	[ -f /usr/share/applications/defaultaudioplayer.desktop ] && [ ! "`grep '^Icon' /usr/share/applications/defaultaudioplayer.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/multimedia48.png" >> /usr/share/applications/defaultaudioplayer.desktop
	[ -f /usr/share/applications/defaultbrowser.desktop ] && [ ! "`grep '^Icon' /usr/share/applications/defaultbrowser.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/www48.png" >> /usr/share/applications/defaultbrowser.desktop
	[ -f /usr/share/applications/defaultimageviewer.desktop ] && [ ! "`grep '^Icon' /usr/share/applications/defaultimageviewer.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/draw48.png" >> /usr/share/applications/defaultimageviewer.desktop
	[ -f /usr/share/applications/defaultmediaplayer.desktop ] && [ ! "`grep '^Icon' /usr/share/applications/defaultmediaplayer.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/multimedia48.png" >> /usr/share/applications/defaultmediaplayer.desktop
	[ -f /usr/share/applications/defaultpdfviewer.desktop ] && [ ! "`grep '^Icon' /usr/share/applications/defaultpdfviewer.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/folder48.png" >> /usr/share/applications/defaultpdfviewer.desktop
	[ -f /usr/share/applications/defaultspreadsheet.desktop ] && [ ! "`grep '^Icon' /usr/share/applications/defaultspreadsheet.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/spread48.png" >> /usr/share/applications/defaultspreadsheet.desktop
	[ -f /usr/share/applications/defaulttexteditor.desktop ] && [ ! "`grep '^Icon' /usr/share/applications/defaulttexteditor.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/edit48.png" >> /usr/share/applications/defaulttexteditor.desktop
	[ -f /usr/share/applications/defaultwordprocessor.desktop ] && [ ! "`grep '^Icon' /usr/share/applications/defaultwordprocessor.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/word48.png" >> /usr/share/applications/defaultwordprocessor.desktop

	#update Manage-favorites .desktop file
	echo -e "[Desktop Entry]\nEncoding=UTF-8\nName=✫Manage menu favorites\nName[de]=✫Verwalten favoriten\nName[es]=✫Administrar favoritas\nName[fr]=✫Gérer favoris\nName[it]=✫Gestire preferiti\nIcon=/usr/local/PupMenu/icons/pmedit48.png\nComment=$(gettext 'Add or remove menu favorites')\nExec=ManageFavorites\nTerminal=false\nType=Application\nCategories=Favorite;" > /usr/share/applications/✫Manage-favorites.desktop

	# Import old PupMenu bookmarks
	[ -f /usr/local/PupMenu/bookmarks ] && grep -v '#' /usr/local/PupMenu/bookmarks >> $HOME/.pbookmarks/bookmarks && rm -f  /usr/local/PupMenu/bookmarks

	#Xdialog --title PupMenu --beep --msgbox "\n All files are installed... \n\n The PupMenu 'Ctrl+Shift+M' hotkey is available for \n IceWM, JWM, Fluxbox, Openbox and LXDE-LXPanel.  \n\n Go to PupMenu Preferences to select options. \n" 0x0+200+100 && exit 0
fi

#END
